/* $Id: CalcGrade.java,v 1.10 2013/01/08 00:00:36 mit Exp $
/* CalcGrade.java v0.1 */
import java.text.DecimalFormat;

public class CalcGrade {
    private boolean Itype;
    private boolean Rev;
    private int Wound;
    private int[] ID;
    private double A49i;
    private double Grade;
    private double[] Inha;
    private double[] Cent;
    private DecimalFormat df1 = new DecimalFormat("#0.0##");

    private final int CENT = 1200;
    private final int KB = 88;
    private final int A49 = 49-1;
    private final int AA = 440;
    private final double Oct = 12.0;
    private final double RevOct = 1.0/Oct;

    public void initGrade(double[] cent) {
	Cent = cent;
    }
    public void setGrade(int ww, double ih, double gr, int[] id, 
			 boolean ty) {
	setWound(ww);
	setA49i(ih);
	setGrade(gr);
	setID(id);
	setItype(ty);
    }
    public void setA49i(double a) {
	A49i = a;
    }
    public void setGrade(double gr) {
	Grade = gr;
    }
    public void setWound(int ww) {
	Wound = ww;
    }
    public void setID(int[] id) {
	ID = id;
    }
    public void setItype(boolean sw) {
	Itype = sw;
    }
    public void setRev(boolean sw) {
	Rev = sw;
    }
    //
    public double[] getInha() {
	return Inha;
    }
    public double getInha(int key) {
	return Inha[key];
    }
    //
    public double get_inha(int key, int par) {
	return Inha[key]*par*par;
    }
    public double get_icent(int pr, int key) {
	return Cent[key]+get_inha(key, pr);
    }
    public double get_freq(int key, int pr) {
	return ctof(getFreq(key)*pr, get_icent(pr, key));
    }
    public double calcBeat(int key, int par) {
	double be0, be1;

	if (Rev) {
	    be0 = get_freq(key-ID[2], ID[0]*par);
	    be1 = get_freq(key, ID[1]*par);
	} else {
	    be0 = get_freq(key+ID[2], ID[1]*par);
	    be1 = get_freq(key, ID[0]*par);
	}

	return be0-be1;
    }
    public void makeInha(double gr) {
	double df, sft = 0;
       	double[] bass = new double[Wound+1];
	int ww = Wound-1; // (0~47)-1
	Inha = new double[KB];
	Grade = gr;

	if (Itype) { // straight
	    for (int i = Wound; i < KB; i++)
		Inha[i] = Math.exp(Grade*i);
	    df = A49i/Inha[A49];
	    for (int i = Wound; i < KB; i++)
		Inha[i] *= df;

	    if (ww >= 0) { // -1ʤ鴬ʤ
		sft = Inha[Wound]; // -1
		for (int i = 0; i < Wound+1; i++) // ޤǺ
		    bass[i] = 1.0/Math.exp(Grade*i);
		df = bass[Wound]/sft;
		for (int i = 0; i < Wound; i++) // -1ޤǤǹ
		    Inha[i] = bass[i]/df;
	    }
	} else { // curve
	    for (int i = 0; i < KB; i++)
		Inha[i] = (Grade < 0) ? 1.0/cosh(Grade*(i-Wound)) :
		    cosh(Grade*(i-Wound));
	    df = A49i/Inha[A49];
	    for (int i = 0; i < KB; i++)
		Inha[i] *= df;
        }
    }
    public double cosh(double x) {
        double me = Math.pow(Math.E, x);

        return (me+1/me)/2;
    }
    public double ctof(double f, double c) {
	return f*Math.pow(2, c/CENT);
    }
    public double getFreq(int key) {
        return AA*Math.pow(2, (key-A49)*RevOct);
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public String toString() {
        StringBuffer sb = new StringBuffer();

	sb.append(" Grade: "+dform(Grade));
	sb.append(" Inha.: "+dform(A49i));
	sb.append(" Wound: "+Wound);
	sb.append(" ID[0]: "+ID[0]);
	sb.append(" ID[1]: "+ID[1]);
	sb.append(" ID[2]: "+ID[2]);
	sb.append(" Itype: "+Itype);
	sb.append(" Rev.: "+Rev);
	sb.append("\n");

	return sb.toString();
    }
}