/* $Id: Igrade.java,v 1.34 2016/09/15 23:36:08 mit3 Exp $
/* Igrade.java v0.4 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.util.*;
import java.text.DecimalFormat;

public class Igrade extends Applet
    implements ActionListener, AdjustmentListener, ItemListener,
	       MouseListener, MouseMotionListener
{
    private Button[] jbGrap;
    private Button[] jbKeys;
    private Button jbTune;
    private Button jbCntP;
    private Button jbCntM;
    private Button jbWidP;
    private Button jbWidM;
    private Button jbType;
    private Button jbText;
    private Scrollbar jslGrd;
    private Scrollbar jslUnr;
    private Scrollbar jslInh;
    private Scrollbar jslBass;
    private TextField tfData;
    private TextArea taA;
    private Label lGrade;
    private Label lInha;
    private Label lBass;
    private Label lBeat;
    private Choice jchItvl; // interval
    private Choice jchPrtl; // partial
    private Canvas can;
    private CardLayout Card;
    private Panel deck;
    private Graphics gi;
    private Image ig;
    private Font Fnt;
    private Panel PN, PE, PW, PS;

    private Interval I;
    private TuningFormula2 TF2;
    private CalcGrade CG;
    private DecimalFormat df1 = new DecimalFormat("#0.0##");

    private final int KB = 88;
    private final int Oct = 12;
    private final int A49 = 49-1;
    private final int INHA = 0;
    private final int CENT = 1;
    private final int BEAT = 2;
    private final int ALLB = 3;
    private final int GRAD = 4;
    private final int MAXP = 20;
    private final String[] Graps = {"Inha.","Cent","Beat","All","Grad."};
    private final String[] Keys = {"->",">",">>"};
    private final String[] Keynm =
    {"A","B","H","C","Cis","D","Es","E","F","Fis","G","Gis"};
    private static final long serialVersionUID = 1L;

    private boolean Msw;
    private boolean Rev; //  def:+
    private boolean Ity; // inha. Curved|Straight
    private boolean Tsw; // tune  tuning|clear
    private boolean GTsw;
    private boolean DRsw;
    private int W, H;
    private int H2, H0;
    private int FNT;
    private int Wound = 28; // wound
    private int Grap;
    private int MaxP = MAXP;
    private int MaxC;    // cent 
    private int Bmax;    // beat
    private int MaxW;    // wide
    private int KEY;
    private int BKEY;
    private int ITVL;
    private double[] Fund;
    private double[] Prtl;

    public void init() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FNT);
        setFont(Fnt);

	I = new Interval();
	TF2 = new TuningFormula2();
	CG = new CalcGrade();
        buildLayout();

	set_enabled();
	init_set();
	initColor();
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;

	H2 = H/2;
	H0 = H-FNT*2;

        can.setSize(W, H);
        ig = createImage(W, H);
        gi = ig.getGraphics();
    }
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
        Dimension ds = PS.getSize();
        Dimension de = PE.getSize();
        Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(ds.height+dn.height)-6;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void buildLayout() {
	setBackground(Color.lightGray);
        setLayout(new BorderLayout());

	PN = new Panel();
	PN.setLayout(new FlowLayout());
	add(PN, "North");

	jbKeys = new Button[Keys.length];
	for (int i = 0; i < Keys.length; i++) {
	    jbKeys[i] = new Button(Keys[i]);
	    jbKeys[i].addActionListener(this);
	    PN.add(jbKeys[i]);
	}

	tfData = new TextField(16);
        tfData.setEditable(false);
        PN.add(tfData);

	jchItvl = new Choice();
        for (int i = 0; i < I.getInum(); i++)
            jchItvl.addItem(I.toString(i));
        PN.add(jchItvl);
        jchItvl.addItemListener(this);

	jchPrtl = new Choice();
        for (int i = 1; i <= MAXP; i++)
            jchPrtl.addItem(""+i);
        PN.add(jchPrtl);
        jchPrtl.addItemListener(this);
	//---

	PW = new Panel();
        PW.setLayout(new GridLayout(Graps.length+2,1,0,0));
	add(PW, "West");

	jbGrap = new Button[Graps.length];
	for (int i = 0; i < Graps.length; i++) {
	    jbGrap[i] = new Button(Graps[i]);
	    jbGrap[i].addActionListener(this);
	    PW.add(jbGrap[i]);
	}

	PW.add(new Label(""));

	jbText = new Button("Text");
        jbText.addActionListener(this);
        PW.add(jbText);
	//-----

	PE = new Panel();
        PE.setLayout(new GridLayout(5,1,0,0));
	add(PE, "East");

	jbCntP = new Button("+");
        jbCntP.addActionListener(this);
        PE.add(jbCntP);

	jbCntM = new Button("-");
        jbCntM.addActionListener(this);
        PE.add(jbCntM);

	PE.add(new Label(""));

	jbWidP = new Button(">");
        jbWidP.addActionListener(this);
        PE.add(jbWidP);

	jbWidM = new Button("<");
        jbWidM.addActionListener(this);
        PE.add(jbWidM);
	//---

	PS = new Panel();
	PS.setLayout(new GridLayout(2,1,0,0));
	add(PS, "South");

	Panel s0 = new Panel();
	s0.setLayout(new GridLayout(1,5,0,0));
        PS.add(s0);

	jbType = new Button("Curved");
	jbType.addActionListener(this);
	s0.add(jbType);

	lGrade = new Label("Grade:_____");
	s0.add(lGrade);

	jslGrd = new Scrollbar(Scrollbar.HORIZONTAL,87,1,0,151); // 
	jslGrd.setBlockIncrement(10);
	jslGrd.setUnitIncrement(1);
	jslGrd.addAdjustmentListener(this);
	s0.add(jslGrd);

	lInha = new Label("Inhar.:_____");
	s0.add(lInha);

	jslInh = new Scrollbar(Scrollbar.HORIZONTAL,55,1,000,111); // inharmo.
	jslInh.setBlockIncrement(10);
	jslInh.setUnitIncrement(1);
	jslInh.addAdjustmentListener(this);
	s0.add(jslInh);
	//

	Panel s1 = new Panel();
	s1.setLayout(new GridLayout(1,5,0,0));
        PS.add(s1);

	jbTune = new Button("Clear");
        jbTune.addActionListener(this);
        s1.add(jbTune);

	lBeat = new Label(" Beat:___");
	s1.add(lBeat);

	jslUnr = new Scrollbar(Scrollbar.HORIZONTAL,10,1,0,31); // ʤ
	jslUnr.setBlockIncrement(10);
	jslUnr.setUnitIncrement(1);
	jslUnr.addAdjustmentListener(this);
	s1.add(jslUnr);

	lBass = new Label("Bass:_____");
	s1.add(lBass);

	jslBass = new Scrollbar(Scrollbar.HORIZONTAL,Wound,1,0,A49+1); // 
	jslBass.setBlockIncrement(10);
	jslBass.addAdjustmentListener(this);
	s1.add(jslBass);
	//---

	can = new myCanvas();
        can.addMouseListener(this);
        can.addMouseMotionListener(this);

        deck = new Panel();
        Card = new CardLayout();
        deck.setLayout(Card);

	Panel card1 = new Panel();
        card1.add(can);
        deck.add(card1, "card1");

        taA = new TextArea("", 16, 48, TextArea.SCROLLBARS_BOTH);
        taA.setFont(Fnt);
        taA.setEditable(false);

        ScrollPane card2 = new ScrollPane();
        card2.add(taA);
        deck.add(card2, "card2");

	add(deck, "Center");
    }
    //
    public void actionPerformed(ActionEvent e){
	for (int i = 0; i < Graps.length; i++) {
	    if (e.getSource() == jbGrap[i]) {
		Grap = i;
		break;
	    }
	}

	if (e.getSource() == jbTune)
	    set_tune();

	else if (e.getSource() == jbKeys[0])
	    revers_key();
	else if (e.getSource() == jbKeys[1])
	    set_key(1);
	else if (e.getSource() == jbKeys[2])
	    set_key(Oct);

	else if (e.getSource() == jbCntP)
	    set_vertical(true);
	else if (e.getSource() == jbCntM)
	    set_vertical(false);

	else if (e.getSource() == jbWidP)
	    set_wide(true);
	else if (e.getSource() == jbWidM)
	    set_wide(false);

	else if (e.getSource() == jbType)
	    change_type();

	else if (e.getSource() == jbText)
            set_graph();

	set_enabled();
	disp_sw();
    }
    //
    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == jslBass) { // 
	    setBass();
	    set_tk();
	}

	if (e.getSource() == jslGrd) // Grade
	    set_tk();
	if (e.getSource() == jslInh) // Inharmo.
	    set_tk();

	disp_sw();
    }
    //
    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == jchPrtl)
	    select_partial();

	if (e.getSource() == jchItvl)
	    set_interval();

	disp_sw();
    }
    //
    public void mousePressed(MouseEvent m) {
	Msw = !Msw;
	disp_sw();
    }
    public void mouseReleased(MouseEvent m) {}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited(MouseEvent m) {}
    public void mouseClicked(MouseEvent m) {}
    public void mouseDragged(MouseEvent me) {
	DRsw = true;

	set_mouseX(me.getX());
	disp_sw();
    }
    public void mouseMoved(MouseEvent me) {
	DRsw = false;

	if (Msw) {
	    set_mouseX(me.getX());

	    disp_sw();
	}
    }
    public void set_mouseX(int mx) {
	KEY = (int)(mx/DW);

	check_key();
	set_bkey();
    }
    //
    public void disp_sw() {
        if (GTsw)
            re_write();
        else
            can.repaint();
    }
    public void set_enabled() {
	boolean gc = (Grap == BEAT);
	jbWidP.setEnabled(gc);
	jbWidM.setEnabled(gc);

	boolean gi = (Grap != INHA);
	jbCntP.setEnabled(gi);
	jbCntM.setEnabled(gi);
    }
    public void init_set() {
	MaxC = 100;  // cent height
	MaxW = 100;  // beats wide
	Bmax = 40;   // for beat
	KEY = A49;
	Fund = new double[MAXP+1];
	Prtl = new double[MAXP+1];

	make_tune();
	set_grade();
	CG.makeInha(getGrad());

	jchItvl.select(I.getIinte(Oct));
	set_interval();
	set_bkey();
	jchPrtl.select(7); // 8-1
	select_partial();

	CG.initGrade(TF2.getCent());
    }
    public void set_graph() {
        GTsw = !GTsw;

        jbText.setLabel(GTsw ? "Grap." : "Text ");
        Card.next(deck);
    }
    public void set_tune() {
	Tsw = !Tsw;
	jbTune.setLabel(Tsw ? "Tune " : "Clear");

	if (Tsw)
	    set_flat();
	else
	    make_tune();

	CG.initGrade(TF2.getCent());
    }
    public void make_tune() {
	if (Ity) {
	    double[] tmp = new double[KB];
	    for (int i = 0; i < KB; i++)
		tmp[i] = get_inha(i);
	    TF2.getInharmonicity(tmp);
	} else {  // TF˶ grade
	    TF2.getInharmonicity(Wound, getInhar(), getGrad());
	}
	TF2.getCurve(getUnari()); // unari() tuningԤ

	set_grade();
    }
    //
    public double get_inha(int key) {
	return CG.getInha(key);
    }
    public void setBass() {
	Wound = getBass();
    }
    public void set_flat() {
	TF2.resetCent();
    }
    public void change_type() {
	int tmp = jslGrd.getValue();

	Ity = !Ity;
	jbType.setLabel(Ity ? "Straight" : "Curved");

	set_tk();
    }
    public void set_tk() {
	TF2.getInharmonicity(Wound, getInhar(), getGrad());

	set_grade();
	CG.makeInha(getGrad());
    }
    public void set_grade() {
	CG.setGrade(Wound, getInhar(), getGrad(), getId(), Ity);
    }
    public void set_base() {
	set_bkey();

	for (int i = 1; i <= MaxP; i++)
	    Fund[i] = getIfreq(BKEY, i);
    }
    public void revers_key() {
	Rev = !Rev;

	jbKeys[0].setLabel(Rev ? "<-" : "->");
	jbKeys[1].setLabel(Rev ? "<" : ">");
	jbKeys[2].setLabel(Rev ? "<<" : ">>");

	KEY = Rev ? KEY+ITVL : KEY-ITVL;

	CG.setRev(Rev);
	check_key();
	set_base();
    }
    public void set_key(int val) {
	KEY += Rev ? -val : val;

	check_key();
	set_base();
    }
    public void check_key() {
	int min = 0;
	int max = KB-1;

	if (Rev) {
	    if (KEY > max)
		KEY = max;
	    else if (KEY-ITVL < min)
		KEY = ITVL;
	} else {
	    if (KEY+ITVL > max)
		KEY = max-ITVL;
	    else if (KEY < min)
		KEY = min;
	}
    }
    public void set_interval() {
	ITVL = getInterval();

	check_key();
	set_base();
	CG.setID(getId());
    }
    public void set_bkey() {
	BKEY = Rev ? KEY-ITVL : KEY+ITVL;
    }
    public void set_vertical(boolean sw) {
	int max, min;
	switch (Grap) {
	case CENT:
	    MaxC = limit_Value(MaxC, 800, 10, sw);
	    break;
	case BEAT:
	case ALLB:
	case GRAD:
	    Bmax = limit_Value(Bmax, 12800, 10, sw);
	    break;
	default:
	}
    }
    public int limit_Value(int val, int max, int min, boolean sw) {
        val = sw ? val*2 : val/2;

        if (val > max)
            val = max;
        if (val > 26 && val < 50)
            val = 50;
        if (val < 26 && val > 10)
            val = 20;
        if (val < min)
            val = min;

        return val;
    }
    public void set_wide(boolean sw) {
	int max = 100;
	int min = 20;
	MaxW = sw ? MaxW+min : MaxW-min;

	if (MaxW > max)
	    MaxW = max;
	else if (MaxW < min)
	    MaxW = min;
    }
    //
    public void re_write() {
	calc_bsf();
	write_data();

	switch(Grap) {
	case INHA:
	    write_inha();
	    break;
	case CENT:
	    write_cent();
	    break;
	case BEAT:
	    write_beats();
	    break;
	case ALLB:
	    write_full();
	    break;
	case GRAD:
	    write_grade();
	    break;
	default:
	}
    }
    public void write_inha() {
	StringBuffer str = new StringBuffer(1024);
	str.append("Key#: Inharmonicity\n");
        str.append("-------------------\n");

	for (int i = 0; i < KB; i++) {
            str.append(getKeynm(i)+" ");
            str.append(dform(getIcent(i)));
	    str.append("\n");
        }

	taA.setText(str.toString());
    }
    public void write_cent() {
	StringBuffer str = new StringBuffer(1024);
        str.append("Key#:     [cent]\n");
        str.append("----------------\n");

        for (int i = 0; i < KB; i++) {
            str.append(getKeynm(i)+" ");
            str.append(dform(getInha(i, 1)));
            str.append("\n");
        }

        taA.setText(str.toString());
    }
    public void write_beats() {
	StringBuffer str = new StringBuffer(1024);
        str.append("Key#:"+getKeynm(KEY)+"\n");
	str.append("[cent]");
	int[] id = getId();
	for (int i = 1; i <= MaxP; i++)
	    str.append(": "+id[0]*i);

	str.append(" (Partial)");
        str.append("\n-------------------------\n");
	int ii;
	double yy;
	for (int i = 0; i <= MaxW; i++) {
	    ii = i-BSF;
	    str.append(ii);
	    for (int j = 1; j <= MaxP; j++) {
		yy = getBeats(KEY, j, ii);
		str.append(": "+dform(yy));
	    }
	    str.append("\n");
	}

	taA.setText(str.toString());
    }
    public void write_full() {
	StringBuffer str = new StringBuffer(1024);
	int[] id = getId();
	int p;

	str.append("Key#");
	for (int i = 1; i <= MaxP; i++) {
	    p = id[0]*i;
	    if (p > MaxP)
		continue;
	    str.append(": "+p);
	}
	str.append(" (Partial)");
        str.append("\n-------------------------\n");

	double dt;
	for (int i = 0; i < KB; i++) {
	    if (!Rev && (i+id[2] < KB) || Rev && (i-id[2] >= 0)) {
		str.append(i+1);
		for (int j = 1; j <= MaxP; j++) {
		    if (id[0]*j > MaxP)
			continue;
		    dt = get_full_beats(i, id, j);
		    str.append(": "+dform(dt));
		}
		str.append("\n");
	    }
	}

	taA.setText(str.toString());
    }
    public void write_grade() {
	StringBuffer str = new StringBuffer();
	double tmpGrade = getGrad();
	double d0 = -MM;
	int[] id = getId();

	str.append("Key#"+getKeynm(KEY)+"\n");
	str.append("Grade ");
	for (int j = 1; j <= MaxP; j++) {
	    if (id[0]*j > MaxP)
		continue;
	    str.append(": "+id[0]*j);
	}
	str.append(" (Partial)\n");
	str.append("-------------------------\n");

	for (int i = 0; i <= NN; i++) {
	    CG.makeInha(d0);
	    str.append(dform(d0)+" ");
	    for (int j = 1; j <= MaxP; j++) {
		if (id[0]*j > MaxP)
		    continue;
		str.append(": "+dform(CG.calcBeat(KEY, j)));
	    }
	    str.append("\n");
	    d0 += DG;
	}

	taA.setText(str.toString());
	CG.makeInha(tmpGrade);
	TF2.getInharmonicity(Wound, getInhar(), tmpGrade);
    }
    //
    public void write_data() {
	write_Unari();
	write_Data();
	write_Grad();
	write_Inha();
	write_Bass();
    }
    public void write_Data() {
	String st;

	switch(Grap) {
	case INHA:
	    st = getKeynm(KEY)+" "+dform(getInha(KEY, 1));
	    break;
	case CENT:
	case BEAT:
	case ALLB:
	case GRAD:
	    st = getKeynm(KEY)+" "+dform(getIcent(KEY))+"[cent]";
	    break;
	default:
	    st = "";
	}

	tfData.setText(st);
    }
    public void write_Unari() {
	lBeat.setText(" Beat:"+dform(getUnari()));
    }
    public void write_Grad() {
	lGrade.setText("Grade:"+dform(getGrad()));
    }
    public void write_Inha() {
	lInha.setText("Inha.:"+dform(getInhar()));
    }
    public void write_Bass() {
	lBass.setText("Bass:"+(getBass()));
    }
    public void select_partial() {
	String sp = jchPrtl.getSelectedItem();
        MaxP = Integer.parseInt(sp);
    }
    public String getKeynm(int key) {
        return (key+1)+"<"+Keynm[key%Oct]+">";
    }
    public int getInteIndex() {
	return jchItvl.getSelectedIndex();
    }
    public int getInterval() {
	return I.getIvalue(getInteIndex());
    }
    public int[] getId() {
	return I.getIdata(getInteIndex());
    }
    public int getBass() {
       	return jslBass.getValue();
    }
    public double getGrad() {
	return jslGrd.getValue()/1000.0;
    }
    public double getUnari() {
	return jslUnr.getValue()/10.0;
    }
    public double getInhar() {
	return jslInh.getValue()/100.0;
    }
    public double getBeats(int key, int pr, double ce) {
       	return calc_beat(getIfreq(key, pr, ce));
    }
    public double calc_beat(double f) {
	double be, min = Double.MAX_VALUE;

	for (int i = 1; i <= MaxP; i++) {
            be = Math.abs(Fund[i]-f);
            if (be < min)
                min = be;
        }

        return min;
    }
    public double getBeats(int key, int pr) {
	return calc_beat(getIfreq(key, pr));
    }
    //
    public double getIfreq(int key, int pr, double ce) {
	return ctof(getFreq(key)*pr, getIcent(key, pr)+ce);
    }
    public double getIfreq(int key, int pr) {
	return ctof(getFreq(key)*pr, getIcent(key, pr));
    }
    public double getInha(int key, int pr) {
	return pr*pr*get_inha(key);
    }
    public double getFreq(int key) {
	return TF2.getFreq(key);
    }
    public double getIcent(int key) {
	return TF2.get_icent(key, 1);
    }
    public double getIcent(int key, int pr) {
	return TF2.get_icent(key, pr);
    }
    public double getCent(int key) {
	return TF2.getCent(key);
    }
    public double ctof(double f, double c) {
	return f*Math.pow(2, c/1200);
    }
    public double log_base(double value) {
	return Math.log(value)/Math.log(10);
    }
    public String dform(double val) {
        return df1.format((float)val);
    }
    //----------

    class myCanvas extends Canvas {
	private static final long serialVersionUID = 1L;

        public void update (Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }

    private int DOT, DSF;
    private int BSF;
    private int NN;
    private double DG = 0.01; // ֳ
    private double MM = 0.15; // 
    private double DX;
    private double DW;   // KB
    private double DI;   // inha.
    private double DC;   // cent
    private double DU;   // beat
    private double DB;   // wide
    private double DV;   // H0
    private Color[] Gc;
    private final String[] Octnm = {
	"A2","A1","A","a","a1","a2","a3","a4"};

    public void paintI() {
	if (!DRsw)
	    back_black(gi);

	setFont(Fnt);
	set_value();
	set_base();
	write_data();

	switch(Grap) {
	case INHA:
	    disp_inha(gi);
	    break;
	case CENT:
	    disp_cent(gi);
	    break;
	case BEAT:
	    disp_beats(gi);
	    break;
	case ALLB:
	    disp_full(gi);
	    break;
	case GRAD:
	    disp_grade(gi);
	    break;
	default:
	}

	/* disp_color_bar(gi); */
    }
    public void back_black(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0, 0, W, H);
    }
    public void set_value() {
	DW = W/(double)KB;
	DB = W/(double)MaxW;
	DC = H/(double)MaxC;
	DU = H/(double)Bmax;
	DV = H0/(double)Bmax;
	DI = H/5.0;
	NN = (int)(MM*2/DG);
	DX = W/(double)NN;

	DOT = (int)DW;
	if (DOT < 2)
	    DOT = 2;
	DSF = DOT/2;
	calc_bsf();
    }
    public void initColor() {
	Gc = new Color[MAXP];
	double dc = 1.0/MAXP;
        float c0, sft = 0.0f;

        for (int i = 0; i < MAXP; i++) {
            c0 = (float)(dc*i+sft);
            if (c0 > 1.0)
                c0 -= 1.0;
            Gc[i] = Color.getHSBColor(c0, 1.0f, 1.0f);
        }
    }
    /*
    public void disp_color_bar(Graphics g) {
	double dc = (double)W/R.length;
	int x, w = (int)dc, bar = 5;
	for (int i = 0; i < R.length; i++) {
	    x = (int)(dc*i);
	    g.setColor(Gc[i]);
	    g.fillRect(x, 0, w, bar);
	} 
    }
    */
    public int getKeyX(int k) {
	return (int)(DW*k);
    }
    public void calc_bsf() {
	BSF = MaxW/2;
    }
    ///*
    public void disp_inha(Graphics g) {
	disp_aline(g);
	disp_log(g);
	int x, y;
	double val;

	for (int i = 0; i < KB; i++) {
	    x = getKeyX(i);
	    val = get_inha(i);
	    if (val <= 0)
		continue;

	    y = (int)(H2-log_base(val)*DI-DSF);

	    set_key_color(g, i);
	    g.fillOval(x, y, DOT, DOT);
	}
    }
    //*/
    /* for debug
    public void disp_inha(Graphics g) {
	disp_aline(g);
	disp_log(g);
	int x;
	double tmpGrade = getGrad();
	double d0 = -MM;

	for (int i = 0; i <= NN; i++) {
	    CG.makeInha(d0);
	    for (int k = 0; k < KB; k++) {
		set_key_color(g, k);
		g.fillOval(getKeyX(k), (int)(H2-log_base(CG.getInha(k))*DI),
			   DOT, DOT);
	    }
	    d0 += DG;
	}

	CG.makeInha(tmpGrade);
    }
    */
    public void disp_log(Graphics g) {
	double h0 = 0.001, hl;
	int hm;

	for (int i = 1; i < 6; i++) { // ʿ
	    hl = h0*Math.pow(10, i);
	    hm = (int)(H2-log_base(hl)*DI);

	    g.setColor(Color.blue);
	    g.drawLine(0, hm, W, hm);

	    g.setColor(Color.orange); // 
	    g.drawString(""+(float)hl, 2, hm);
	}
    }
    //
    public void disp_cent(Graphics g) {
	disp_aline(g);
	disp_cline(g);
	int x, y;

	for (int i = 0; i < KB; i++) {
	    x = getKeyX(i);
	    //y = (int)(H2-getIcent(i)*DC-DSF);
	    y = (int)(H2-getCent(i)*DC-DSF);

	    set_key_color(g, i);
	    g.fillOval(x, y, DOT, DOT);

	    //g.setColor(Color.gray);
	    //y = (int)(H2-TF2.calcE(i)*DC-DSF);
	    //g.fillOval(x, y, DOT, DOT);
	}
    }
    public void disp_cline(Graphics g) {
	disp_horizontal_line(g, MaxC, DC);
    }
    public void disp_horizontal_line(Graphics g, int hx, double dy) {
	int dh, hp, hm, xs = 2;
	double hy;

	disp_center_line(g);

	for (int i = 1; i < 6; i++) {
	    dh = hx*i/10;
	    hy = dy*dh;
	    hp = (int)(H2+hy);
	    hm = (int)(H2-hy);

	    g.setColor(Color.blue);
	    g.drawLine(0, hm, W, hm);
	    g.drawLine(0, hp, W, hp);

	    g.setColor(Color.yellow);
	    g.drawString(""+dh, xs+2, hm+FNT);
	    g.drawString("-"+dh, xs, hp);
	}
    }
    public void disp_center_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2, W, H2);
    }
    public void disp_aline(Graphics g) {
	int wi;

	for (int i = 0; i < KB; i += Oct) { //akeyľ
	    wi = (int)(DSF+DW*i);

	    g.setColor(Color.blue);
	    g.drawLine(wi, 0, wi, H);

	    g.setColor(Color.red); // octav name
	    g.drawString(Octnm[i/Oct], wi, H-FNT);
	}
    }
    public void set_key_color(Graphics g, int val) {
	if (val == BKEY)
	    g.setColor(Color.magenta);
	else if (val == KEY)
	    g.setColor(Color.green);
	else if (val >= Wound)
	    g.setColor(Color.white);
	else
	    g.setColor(Color.pink);
    }
    //
    public void disp_beats(Graphics g) {
	disp_memori(g);
	disp_label(g);
	disp_value(g);
	int x, y, x0 = 0, y0 = 0;
	int dot = (int)DB;
	if (dot < 4)
	    dot = 4;
	else if (dot > 8)
	    dot = 8;
	int dsf = dot/2;

	for (int j = 1; j <= MaxP; j++) {
	    g.setColor(Gc[j-1]);
	    for (int i = 0; i <= MaxW; i++) {
		x = (int)(DB*i);
		y = (int)(H0-getBeats(KEY, j, i-BSF)*DV);
		if (y > -H0) {                   // ɬ
		    if (i != 0)
			g.drawLine(x0, y0, x, y);
		    g.fillOval(x-dsf, y-dsf, dot, dot);
		}
		x0 = x;
		y0 = y;
	    }
	}
    }
    public void disp_memori(Graphics g) {
	int lin = 5, tln = 10, x, l;

	g.setColor(Color.lightGray);
	for (int i = 0; i <= MaxW; i++) {
	    x = (int)(DB*i);
	    l = (i%10 == 0) ? tln : lin;

	    g.drawLine(x, H0, x, H0+l);
	}

	g.setColor(Color.gray);
	g.drawLine(W/2, 0, W/2, H);
    }
    public void disp_label(Graphics g) {
	int xp, xm, w2 = W/2;
	double di;

	g.setColor(Color.pink);
	for (int i = 10; i <= MaxW/2; i += 10) {
	    di = DB*i;
	    xm = (int)(w2-di);
	    xp = (int)(w2+di-FNT);

	    g.drawString("-"+i, xm, H);
	    g.drawString(""+i, xp, H);
	}
	g.drawString("0", w2, H);
    }
    public void disp_value(Graphics g) {
	int y, l = 3;

	g.setColor(Color.lightGray);
	for (int i = 0; i < Bmax; i++) {
	    y = (int)(H0-DV*i);
	    if (i%1000 == 0)
		l = 12;
	    else if (i%100 == 0)
		l = 9;
	    else if (i%10 == 0 && Bmax < 700)
		l = 6;
	    else if (Bmax < 200)
		l = 3;
	    else
		continue;

	    g.drawLine(1, y, l, y);
	}

	g.setColor(Color.red);
	g.drawString(""+Bmax, W/2, FNT);

	g.setColor(Color.gray);
	g.drawLine(0, H0, W, H0);
    }
    //
    public void disp_full(Graphics g) {
	disp_full_line(g);
	int[] id = getId();

	Color nc;
	for (int j = 1; j <= MaxP; j++) {
	    if (id[0]*j > MaxP) // ܿ
		break;

	    nc = get_full_color(id, j); // ܲο
	    for (int i = 0; i < KB; i++) {
		if (!Rev && (i+id[2] < KB) || Rev && (i-id[2] >= 0))
		    disp_full_sub(g, i, j, id, nc);
	    }
	}
    }
    public void disp_full_sub(Graphics g, int k, int p, int[] id, Color c) {
	int h = (int)(H2-get_full_beats(k, id, p)*DU-DSF);
	if (h > H || h < 0)
	    return;

	g.setColor((KEY == k) ? Color.white : c);
	g.fillOval(getKeyX(k), h, DOT, DOT);
    }
    public Color get_full_color(int[] id, int pe) {
	int c = Rev ? id[1]*pe : id[0]*pe;

	return Gc[c-1];
    }
    public double get_full_beats(int k, int[] id, int pe) {
	double be0, be1;

	if (Rev) {
	    be0 = getIfreq(k-id[2], id[0]*pe);
	    be1 = getIfreq(k, id[1]*pe);
	} else {
	    be0 = getIfreq(k+id[2], id[1]*pe);
	    be1 = getIfreq(k, id[0]*pe);
	}
	return be0-be1;
    }
    public void disp_full_line(Graphics g) {
	disp_horizontal_line(g, Bmax, DU); 
	disp_aline(g);
    }
    //
    public void disp_grade(Graphics g) {
	double be, d0 = -MM;  // Ǿͤ
	double tmpGrade = getGrad(); // 饤ͤ¸
	int[] id = getId();
	int x, y;
	int dot = (int)(DX/2);
	int dsf = dot/2;

	disp_curve_line(g);
	disp_horizontal_line(g, Bmax, DU);
	disp_grade_bar(g);

	for (int i = 0; i <= NN; i++) {
	    x = (int)(DX*i-dsf);
	    CG.makeInha(d0);
	    /* disp_grade_inha(g); // for debug */

	    disp_partial(g, id, x, dot, dsf);
	    d0 += DG;
	}

	CG.makeInha(tmpGrade);
	TF2.getInharmonicity(Wound, getInhar(), tmpGrade);
    }
    public void disp_partial(Graphics g, int[] id, int x, int dot, int dsf) {
    	double be;
	int y;

	for (int j = 1; j <= MaxP; j++) {
	    if (id[0]*j > MaxP)
		break;

	    be = CG.calcBeat(KEY, j);
	    y = (int)(H2-be*DU-dsf);
	    if (y < 0 || y > H)
		continue;

	    g.setColor(get_full_color(id, j));
	    g.fillOval(x, y, dot, dot);
	}
    }
    /*
    public void disp_grade_inha(Graphics g) { // for debug
	g.setColor(Color.gray);
	for (int k = 0; k < KB; k++)
	    g.fillOval(getKeyX(k), (int)(H2-log_base(CG.getInha(k))*DI), DOT, DOT);
    }
    */
    public void disp_curve_line(Graphics g) {
	int x;
	disp_center_line(g);

	g.setColor(Color.darkGray);
	for (int i = 0; i <=NN; i++) {
	    x = (int)(DX*i);
	    g.drawLine(x, 0, x, H);
	}

	int h0 = H-FNT;
	g.setColor(Color.red);
	g.drawString("-"+MM, 1, h0);
	g.drawString(""+MM, W-30, h0);
	g.drawString("0", W/2, h0);
    }
    public void disp_grade_bar(Graphics g) {
	int gbar = (int)(W/2+W*getGrad()/(2*MM)); 

	g.setColor(Color.lightGray);
	g.drawLine(gbar, 0, gbar, H);
    }
}
